(*Generated by Lem from string_extra.lem.*)
(******************************************************************************)
(* String functions                                                           *)
(******************************************************************************)

open Lem_basic_classes
open Lem_num
open Lem_list
open Lem_string
open Lem_list_extra


(******************************************************************************)
(* Character's to numbers                                                     *)
(******************************************************************************)

(*val ord : char -> nat*)

(*val chr : nat -> char*)

(******************************************************************************)
(* Converting to strings                                                      *)
(******************************************************************************)

(*val stringFromNatHelper : nat -> list char -> list char*)
let rec stringFromNatHelper n acc:(char)list=
   (if n = 0 then
    acc
  else
    stringFromNatHelper (n / 10) (Char.chr ((n mod 10) + 48) :: acc))

(*val stringFromNat : nat -> string*)

(*val stringFromNaturalHelper : natural -> list char -> list char*)
let rec stringFromNaturalHelper n acc:(char)list=
   (if Nat_big_num.equal n( (Nat_big_num.of_int 0)) then
    acc
  else
    stringFromNaturalHelper ( Nat_big_num.div n( (Nat_big_num.of_int 10))) (Char.chr (Nat_big_num.to_int ( Nat_big_num.add (Nat_big_num.modulus n( (Nat_big_num.of_int 10)))( (Nat_big_num.of_int 48)))) :: acc))

(*val stringFromNatural : natural -> string*)

(*val stringFromInt : int -> string*)

(*val stringFromInteger : integer -> string*)


(******************************************************************************)
(* List-like operations                                                       *)
(******************************************************************************)

(*val nth : string -> nat -> char*)
(*let nth s n:char=  List_extra.nth (toCharList s) n*)

(*val stringConcat : list string -> string*)
(*let stringConcat s:string=
   List.foldr (^) "" s*)

(******************************************************************************)
(* String comparison                                                          *)
(******************************************************************************)

(*val stringCompare : string -> string -> ordering*)

let stringLess x y:bool=  (Lem.orderingIsLess (compare x y))
let stringLessEq x y:bool=  (not (Lem.orderingIsGreater (compare x y)))
let stringGreater x y:bool=  (stringLess y x)
let stringGreaterEq x y:bool=  (stringLessEq y x)

let instance_Basic_classes_Ord_string_dict:(string)ord_class= ({

  compare_method = compare;

  isLess_method = stringLess;

  isLessEqual_method = stringLessEq;

  isGreater_method = stringGreater;

  isGreaterEqual_method = stringGreaterEq})
 
